//########## Night Vision Goggles

//### Sounds

datablock AudioProfile(gc_NVOnSound)
{
  filename = "./nvon.wav";
  description = AudioClosest3d;
  preload = true;
};

datablock AudioProfile(gc_NVOffSound)
{
  filename = "./nvoff.wav";
  description = AudioClosest3d;
  preload = true;
};

//### Item

datablock ItemData(gc_NVItem)
{
  uiName = "Night Vision Goggles";
  iconName = "./icon_nv";
  image = gc_NVImage;
  category = "Tools";
  className = "Weapon";
  shapeFile = "./nvitem.dts";
  mass = 0.5;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
};

//### Item Image

datablock ShapeBaseImageData(gc_NVImage)
{
  shapeFile = "./nvitem.dts";
  emap = true;
  mountPoint = 0;
  offset = "0 0 0";
  eyeOffset = "0 0 0";
  rotation = eulerToMatrix("0 0 0");
  className = "WeaponImage";
  item = gc_NVItem;
  melee = false;
  doReaction = false;
  armReady = false;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.1;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;

  stateName[2] = "Fire";
  stateTransitionOnTimeOut[2] = "Ready";
  stateTimeoutValue[2] = "0.2";
  stateFire[2] = true;
  stateAllowImageChange[2] = true;
  stateScript[2] = "onFire";
};

function gc_NVImage::onFire(%this,%obj,%slot)
{
  %client = %obj.client;
  %player = %obj;
  if(isObject(%player))
  {
    if(%player.getMountedImage(2) $= nametoID(gc_NVMaskImage))
    {
      %player.unmountImage(2);
      serverPlay3D(gc_NVOffSound,%obj.getTransform());
    }
    else
    {
      %player.unmountImage(2);
      %player.mountImage(gc_NVMaskImage,2);
      serverPlay3D(gc_NVOnSound,%obj.getTransform());
    }
  }
}

package gc_NVPackage
{
  function servercmdDropTool(%this,%slot)
  {
    if(isobject(%this.player.tool[%slot]) && %this.player.tool[%slot].getname() $= "gc_NVItem")
    {
      parent::servercmdDropTool(%this,%slot);
      if(isobject(%this.player.getmountedimage(2)) && %this.player.getmountedimage(2).getname() $= "gc_NVMaskImage") { %this.player.schedule(5,unmountimage,2); }
      return;
    }
    parent::servercmdDropTool(%this,%slot);
  }
};
activatepackage(gc_NVPackage);

//### Special Images

datablock ShapeBaseImageData(gc_NVMaskImage)
{
  shapeFile = "./nv.dts";
  emap = true;
  mountPoint = $HeadSlot;
  offset = "0 0 0";
  eyeOffset = "0 0 0";
  rotation = eulerToMatrix("0 0 0");
  eyeRotation = eulerToMatrix("90 0 0");
  scale = "1 1 1";
  correctMuzzleVector = true;
  doColorShift = false;
  colorShiftColor = "1 1 1 1";
//  hasLight = true;
//  lightType = "ConstantLight";
//  lightColor = "0.5 1 0.5 0.05";
//  lightTime = "1000";
//  lightRadius = "50";
};
